--push lib--
--g_OSType : 0 Android 1 IOS 2WinPhone

if not G_Push then
	G_Push = {}
end

local G_Push = G_Push

G_Push.enOSAndroid 	   = 0
G_Push.enOSIOS 		       = 1
G_Push.defBreatheInterval = 60
G_Push.defOffsetInterval    = 180
G_Push.defMinInterval	    = 360

function G_Push:Id2String( nId )
	if not self.pStringRes then
		return ''
	end
	
	return self.pStringRes:GetStr( nId + 2 , 2 )
end

function G_Push:DBGetStr( szSec , szKey , szDefault )
	if not G_Push.pPushDB then
		return ''
	end
	return self.pPushDB:GetStr( szSec , szKey , szDefault  ) 
end

function G_Push:DBGetInt( szSec , szKey , nDef )
	if not G_Push.pPushDB then
		return nDef
	end
	return self.pPushDB:GetInt( szSec , szKey , nDef  ) 
end

function G_Push:DBSetVal( szSec , szKey , szVal )
	if not G_Push.pPushDB then
		return
	end
	return self.pPushDB:WriteVal( szSec , szKey , szVal  ) 
end

function G_Push:ClockPerDayArrange( nClock ,  szTitle , szContent , nMinitue  )

    if not nMinitue then
    	nMinitue = 0
    end
    
	local tCurTime =  SGetTime( )
	local tCurData = G_Push.DataUtil[1]
	SToDataTime( tCurTime, tCurData )
	
	local tChkData = G_Push.DataUtil[2]
	if tCurData.Hour > nClock or ( tCurData.Hour == nClock and tCurData.Minute >= nMinitue + 4 ) then 
		local tChkTime = tCurTime + 24 * 3600
		SToDataTime( tChkTime, tChkData )
	else
		 tChkData 		  = tCurData
	end
	
	tChkData.Hour     = nClock
	tChkData.Minute  = nMinitue
	tChkData.Second = 0
	
	local tToTriggerTime = SFromDataTime( tChkData ) 	
	self:Arrange( szTitle , szContent , tToTriggerTime , 0 , 24 * 3600  )
end

function G_Push:ClockPerWeekArrange( nBeginWDay, nEndWDay, nClock, nMinute, szTitle, szContent )
	if nBeginWDay > nEndWDay then
		local nTmp = nBeginWDay
		nBeginWDay = nEndWDay
		nEndWDay = nTmp
	end

	local tCurTime = SGetTime( )
	local tCurDate= G_Push.DataUtil[1]
	SToDataTime( tCurTime, tCurDate )
	for nDay = nBeginWDay, nEndWDay do
		local tDstDate = G_Push.DataUtil[2]
		SToDataTime( tCurTime, tDstDate )
		tDstDate.Day		= tCurDate.Day - tCurDate.WeekDay + nDay
		tDstDate.Hour		= nClock
		tDstDate.Minute		= nMinute
		tDstDate.Second		= 0
		local nDstTime		= SFromDataTime( tDstDate )
		if nDstTime + 240 < tCurTime then
			tDstDate.Day		= tCurDate.Day - tCurDate.WeekDay + 7 + nDay
			nDstTime = SFromDataTime( tDstDate )
		end

		self:Arrange( szTitle, szContent, nDstTime, 0, 24 * 3600 * 7 )
	end
end

function G_Push:ClockPerMonthArrange( nBeginMDay, nEndMDay, nClock, nMinute, szTitle, szContent )
	if nBeginMDay > nEndMDay then
		local nTmp = nBeginMDay
		nBeginMDay = nEndMDay
		nEndMDay = nTmp
	end

	local tCurTime = SGetTime( )
	local tCurDate= G_Push.DataUtil[1]
	SToDataTime( tCurTime, tCurDate )
	for nDay = nBeginMDay, nEndMDay do
		local tDstDate = G_Push.DataUtil[2]
		SToDataTime( tCurTime, tDstDate )
		tDstDate.Day		= tCurDate.Day - tCurDate.Day + nDay
		tDstDate.Hour		= nClock
		tDstDate.Minute		= nMinute
		tDstDate.Second		= 0
		local nDstTime		= SFromDataTime( tDstDate )
		if nDstTime + 240 < tCurTime then
			tDstDate.Month	= tDstDate.Month + 1
			nDstTime		= SFromDataTime( tDstDate )
		end

		self:Arrange( szTitle, szContent, nDstTime, 0, 0 )
	end
end

function G_Push:SpecialWeekTimeCalc( nBaseTime , nWeekDay  , nClock, nMinute )

	local tCurTime = nBaseTime
	local tCurData = G_Push.DataUtil[1]
	SToDataTime( tCurTime, tCurData )
	
	local tDstDate = G_Push.DataUtil[2]
	SToDataTime( tCurTime, tDstDate )
	
	tDstDate.Day			= tCurDate.Day - tCurDate.WeekDay + nWeekDay
	tDstDate.Hour		= nClock
	tDstDate.Minute		= nMinute
	tDstDate.Second	= 0
	local nDstTime		= SFromDataTime( tDstDate )
	if nDstTime + 240 < tCurTime then
		tDstDate.Day		= tCurDate.Day - tCurDate.WeekDay + 7 + nDay
		nDstTime = SFromDataTime( tDstDate )
	end
	return nDstTime
end

function G_Push:SpecialTimeTriggerCalc( nBaseTime ,  nCompClock , nTriggerClock , nOffsetDay , nCompMinite , nTriggerMinitue  )
	
	if not nCompMinite then
		nCompMinite = 0
	end
	
	if not nTriggerMinitue then
		nTriggerMinitue = 0
	end
    
	local tCurTime =  nBaseTime
	local tCurData = G_Push.DataUtil[1]
	SToDataTime( tCurTime, tCurData )
	
	local tChkData = G_Push.DataUtil[2]
	if tCurData.Hour > nCompClock or ( tCurData.Hour == nCompClock and tCurData.Minute >= nCompMinite + 4 )  then 
		nOffsetDay      = nOffsetDay + 1
	end
	
	local tChkTime = tCurTime + nOffsetDay * 24 * 3600
	SToDataTime( tChkTime, tChkData )
	
	tChkData.Hour     = nTriggerClock
	tChkData.Minute  = nTriggerMinitue
	tChkData.Second = 0
	
	local tToTriggerTime = SFromDataTime( tChkData ) 	
	return tToTriggerTime
end

function G_Push:DesignerSchedule( )
		local Random=math.random(100) - 1 
		G_Push:ClockPerDayArrange(12,G_Push:Id2String(7),G_Push:Id2String(8),25) 
		G_Push:ClockPerDayArrange(20,G_Push:Id2String(9),G_Push:Id2String(10),25) 
		G_Push:Arrange(G_Push:Id2String(13),G_Push:Id2String(14),G_Push:SpecialTimeTriggerCalc(G_Push:UserGetInt('Player',"LastEnter",0),0,17,7,0,30),0,0) 
		G_Push:Arrange(G_Push:Id2String(15),G_Push:Id2String(16),G_Push:SpecialTimeTriggerCalc(G_Push:UserGetInt('Player',"LastEnter",0),0,17,15,0,30),0,604800) 
		G_Push:Arrange(G_Push:Id2String(37),G_Push:Id2String(38),G_Push:SpecialWeekTimeCalc(SGetTime(),3,12,15),0,0) 
		G_Push:Arrange(G_Push:Id2String(37),G_Push:Id2String(38),G_Push:SpecialWeekTimeCalc(SGetTime(),5,12,15),0,0) 
		G_Push:Arrange(G_Push:Id2String(37),G_Push:Id2String(38),G_Push:SpecialWeekTimeCalc(SGetTime(),7,12,15),0,0) 
		G_Push:Arrange(G_Push:Id2String(37),G_Push:Id2String(38),G_Push:SpecialWeekTimeCalc(SGetTime(),3,20,0),0,0) 
		G_Push:Arrange(G_Push:Id2String(37),G_Push:Id2String(38),G_Push:SpecialWeekTimeCalc(SGetTime(),5,20,0),0,0) 
		G_Push:Arrange(G_Push:Id2String(37),G_Push:Id2String(38),G_Push:SpecialWeekTimeCalc(SGetTime(),7,20,0),0,0) 
		G_Push:Arrange(G_Push:Id2String(39),G_Push:Id2String(40),G_Push:SpecialWeekTimeCalc(SGetTime(),2,12,15),0,0) 
		G_Push:Arrange(G_Push:Id2String(39),G_Push:Id2String(40),G_Push:SpecialWeekTimeCalc(SGetTime(),4,12,15),0,0) 
		G_Push:Arrange(G_Push:Id2String(39),G_Push:Id2String(40),G_Push:SpecialWeekTimeCalc(SGetTime(),2,20,0),0,0) 
		G_Push:Arrange(G_Push:Id2String(39),G_Push:Id2String(40),G_Push:SpecialWeekTimeCalc(SGetTime(),4,20,0),0,0) 
		G_Push:Arrange(G_Push:Id2String(41),G_Push:Id2String(42),G_Push:SpecialWeekTimeCalc(SGetTime(),5,20,0),0,0) 
		G_Push:Arrange(G_Push:Id2String(41),G_Push:Id2String(42),G_Push:SpecialWeekTimeCalc(SGetTime(),6,20,0),0,0) 
		G_Push:Arrange(G_Push:Id2String(41),G_Push:Id2String(42),G_Push:SpecialWeekTimeCalc(SGetTime(),7,20,0),0,0) 
		G_Push:Arrange(G_Push:Id2String(45),G_Push:Id2String(46),G_Push:SpecialWeekTimeCalc(SGetTime(),1,17,30),0,0) 
		G_Push:Arrange(G_Push:Id2String(45),G_Push:Id2String(46),G_Push:SpecialWeekTimeCalc(SGetTime(),3,17,30),0,0) 
		G_Push:Arrange(G_Push:Id2String(45),G_Push:Id2String(46),G_Push:SpecialWeekTimeCalc(SGetTime(),5,17,30),0,0) 
		G_Push:Arrange(G_Push:Id2String(43),G_Push:Id2String(44),G_Push:SpecialWeekTimeCalc(SGetTime(),2,17,30),0,0) 
		G_Push:Arrange(G_Push:Id2String(43),G_Push:Id2String(44),G_Push:SpecialWeekTimeCalc(SGetTime(),4,17,30),0,0) 
		if G_Push:UserGetInt('Player',"TotalLogin",0) == 1  then  
		else
		end
		if G_Push:UserGetInt('Player',"TotalLogin",0) == 2  then  
		else
		end
		if G_Push:UserGetInt('Player',"TotalLogin",0) == 3  then  
		else
		end
		if G_Push:UserGetInt('Player',"TotalLogin",0) == 4  then  
		else
		end
		if G_Push:UserGetInt('Player',"TotalLogin",0) == 5  then  
		else
		end
		if G_Push:UserGetInt('Player',"TotalLogin",0) == 6  then  
		else
		end
		if G_Push:UserGetInt('Player',"WeddingTime",0) ~= 0   then  
			if ( G_Push:UserGetInt('Player',"Job",0) == 0  )  or  ( G_Push:UserGetInt('Player',"Job",0) == 3  )   then  
				G_Push:Arrange(G_Push:Id2String(29),G_Push:Id2String(30),G_Push:UserGetInt('Player',"WeddingTime",0) - 300,0,0) 
			else
				G_Push:Arrange(G_Push:Id2String(31),G_Push:Id2String(32),G_Push:UserGetInt('Player',"WeddingTime",0) - 300,0,0) 
			end
		else
		end
		if G_Push:UserGetInt('Player',"NotifyLeagueWar",0) == 1  then  
			G_Push:SpecialWeekTimeCalc(SGetTime(),2,17,45) 
			G_Push:SpecialWeekTimeCalc(SGetTime(),3,17,45) 
			G_Push:SpecialWeekTimeCalc(SGetTime(),4,17,45) 
		else
		end
end

function G_Push:Schedule( )

	--clear first
	self.ScheduleRec = {	}
	self:ClearNotify( )
	
	--user data
	self:ReloadUser( )
	
	--user strategy
	self:DesignerSchedule( )
	
end

function G_Push:Breathe( )
	local tbToClear = {	}
	for i , v in pairs( G_Push.ScheduleRec ) do 
		local tbNotify    = v
		local uTimeCur = SGetTime( )
		if uTimeCur >= tbNotify. firetime then
			if uTimeCur < tbNotify. firetime + G_Push.defOffsetInterval and uTimeCur > self:DBGetInt(  "System" , "LastTrigger" , 0 ) + self.defMinInterval  then
			    print( 'Push:'..tbNotify.content )
				self:TriggerNotify( tbNotify.title , tbNotify.content , tbNotify.firetime , 0 , 0 )
				
				if self.pPushDB then
					self.pPushDB:WriteVal( "System" , "LastTrigger" , SGetTime( ) )
					self.pPushDB:Save( "./push/pushdb.ini" )
				end
			end
			
			if tbNotify.repeatInterval == 0 then
				table.insert( tbToClear , i )
			else
				tbNotify.firetime = tbNotify.firetime + tbNotify.repeatInterval
			end
			
		end
	end
	
	--Clear
	for i , v in pairs( tbToClear ) do 
		local tbKeyToClear   = v
		G_Push.ScheduleRec[ tbKeyToClear ] = nil
	end
end

function G_Push:UserGetStr( szSec , szKey , szDefault )
	if not G_Push.pUserCfg then
		return ''
	end
	return self.pUserCfg:GetStr( szSec , szKey , szDefault  ) 
end

function G_Push:UserGetInt( szSec , szKey , nDef )
	if not G_Push.pUserCfg then
		return nDef
	end
	return self.pUserCfg:GetInt( szSec , szKey , nDef  ) 
end

function G_Push:UserSetStr( szSec, szKey, szString )
	if not G_Push.pUserCfg then
		return
	end
	G_Push.pUserCfg:WriteVal( szSec, szKey, szString )
	G_Push.pUserCfg:Save( "./users/pushinfo.ini" )
end 

function G_Push:UserSetInt( szSec, szKey, nNumber )
	if not G_Push.pUserCfg then
		return
	end
	G_Push.pUserCfg:WriteVal( szSec, szKey, tostring( nNumber ) )	
	G_Push.pUserCfg:Save( "./users/pushinfo.ini" )
end 

function G_Push:ClearPriority( )
	G_Push.Priorities = {}
end

function G_Push:PushPriorytiy( szTitle , szContent , nFireTime , szKey, nWeight )
    if nFireTime == 0 then
    	nFireTime = SGetTime( )
    end
	local push = {  }
	push.title = szTitle
	push.content = szContent
	push.firetime = nFireTime
	push.weight  = nWeight
	push.key		= szKey
	table.insert( G_Push.Priorities , push  )
end

function G_Push:Arrange( szTitle , szContent , nFireTime , nRepeatCnt , nRepeatInterval )

    if nFireTime == 0 then
    	nFireTime = SGetTime( )
    end
    
    print( 'To Trigger:' .. nFireTime .. 'Times:' .. nRepeatInterval ..'RepeatCnt'..nRepeatCnt )
    
	if g_OSType == G_Push.enOSAndroid then
		local push = {  }
		push.title = szTitle
		push.content = szContent
		push.firetime = nFireTime
		push.repeatcnt = nRepeatCnt
		push.repeatInterval = nRepeatInterval		
		
		table.insert( G_Push.ScheduleRec , push  )
	else
		
		--Ͳ
    	if SGetTime( ) > nFireTime + G_Push.defOffsetInterval then
    		return
    	end
    
		self:TriggerNotify( szTitle , szContent , nFireTime , nRepeatCnt , nRepeatInterval )
	end
end

function G_Push:FirePriority( )

	local function SortWeight( tbLeft, tbRight )
		return tbLeft.weight < tbRight.weight
	end
	
	table.sort( G_Push.Priorities , SortWeight  )
	
	local tbToFire = G_Push.Priorities[1]
	if tbToFire then
		self:TriggerNotify(  tbToFire.title ,  tbToFire.content , tbToFire.firetime )
	end
end

function G_Push:ReloadUser( )
	if G_Push.pUserCfg then
		G_Push.pUserCfg:delete( )
		G_Push.pUserCfg = nil
	end

	G_Push.pUserCfg = SIniFile:new( )
	G_Push.pUserCfg:Load( "./users/pushinfo.ini" )
end

-- Reload-------------------------------------------
--StringRes
if G_Push.pStringRes then
	G_Push.pStringRes:delete( )
	G_Push.pStringRes = nil
end
G_Push.pStringRes = STabFile:new( )
G_Push.pStringRes:Load( "./push/pushstring.txt" )

--Data base
if G_Push.pPushDB then
	G_Push.pPushDB:delete( )
	G_Push.pPushDB = nil
end

G_Push.pPushDB = SIniFile:new( )
G_Push.pPushDB:Load( "./push/pushdb.ini" )

--User info
G_Push:ReloadUser( )

--Tools --------------------------------------
G_Push.Priorities = {}
if not G_Push.DataUtil  then
	G_Push.DataUtil = {}
	for i = 1,4,1 do 
		G_Push.DataUtil[i] = SDATETIME:new( )
	end
end

--Schedule ----------------------
G_Push.ScheduleRec = {}

--ȡǰϵͳʱ
function G_Push:SaveCurTime( )
	local tCurTime =  SGetTime( )
	local tCurData = G_Push.DataUtil[1]
	SToDataTime( tCurTime, tCurData )
end

function G_Push:SaveSpecTime( uTime )
	local tCurData = G_Push.DataUtil[1]
	SToDataTime( uTime, tCurData )
end

--ȡ
function G_Push:GetYear( uTime  )
	G_Push:SaveSpecTime( uTime )
	return G_Push.DataUtil[1].Year
end

--ȡ
function G_Push:GetMonth( uTime )
	G_Push:SaveSpecTime( uTime )
	return G_Push.DataUtil[1].Month
end

--ȡ
function G_Push:GetDay( uTime )
	G_Push:SaveSpecTime( uTime )
	return G_Push.DataUtil[1].Day
end

--ȡܼ
function G_Push:GetWeekDay( uTime )
	G_Push:SaveSpecTime( uTime )
	return G_Push.DataUtil[1].WeekDay
end

--ȡСʱ
function G_Push:GetHour( uTime )
	G_Push:SaveSpecTime( uTime )
	return G_Push.DataUtil[1].Hour
end

--ȡ
function G_Push:GetMinute( uTime )
	G_Push:SaveSpecTime( uTime )
	return G_Push.DataUtil[1].Minute
end

--ȡ
function G_Push:GetSecond( uTime )
	G_Push:SaveSpecTime( uTime )
	return G_Push.DataUtil[1].Second
end


--Fireout------------------------------------------------
--ȷдִУĳЩϴlogᵼ崻
G_Push:TimeStartup( G_Push.defBreatheInterval )

